Index: binaries/data/mods/public/maps/random/realisticTerrainDemo.js
===================================================================
--- binaries/data/mods/public/maps/random/realisticTerrainDemo.js	(revision 0)
+++ binaries/data/mods/public/maps/random/realisticTerrainDemo.js	(working copy)
@@ -0,0 +1,522 @@
+/**
+*	ToDo:
+*	Add further biomes
+*	Place start locations of one team close to each other
+*	Raise the entire map if to much water
+*
+*	Add support for circular maps
+*	Add parameters for match setup screen (for later use and demonstration)
+*
+*	Extract some functions to an RMGEN lib
+*	Sort out unneeded functions calling other functions
+*	Clean up
+*/
+
+/**
+* DEBUG Start Timer
+*/
+var genStartTime = new Date().getTime();
+
+RMS.LoadLibrary("rmgen");
+
+const BUILDING_ANGlE = -PI/4;
+
+/**
+* initialize map
+*/
+log("Initializing map...");
+InitMap();
+
+
+/**
+*  Some general functions
+*/
+
+/**
+*	Takes an array of 2D points (arrays of length 2)
+*	Returns the order to go through the points for the shortest closed path (array of indices)
+*/
+function getOrderOfPointsForShortestClosePath(points)
+{
+	var order = [];
+	var distances = [];
+	if (points.length <= 3)
+	{
+		for (var i = 0; i < points.length; ++i)
+			order.push(i);
+		
+		return order;
+	}
+	
+	// Just add the first 3 points
+	var pointsToAdd = deepcopy(points);
+	for (var i = 0; i < min(points.length, 3); ++i)
+	{
+		order.push(i)
+		pointsToAdd.shift(i);
+		if (i)
+			distances.push(getDistance(points[order[i]].x, points[order[i]].y, points[order[i - 1]].x, points[order[i - 1]].y));
+	}
+	distances.push(getDistance(points[order[0]].x, points[order[0]].y, points[order[order.length - 1]].x, points[order[order.length - 1]].y))
+	
+	// Add remaining points so the path lengthens the least
+	var numPointsToAdd = pointsToAdd.length;
+	for (var i = 0; i < numPointsToAdd; ++i)
+	{
+		var indexToAddTo = undefined;
+		var minEnlengthen = Infinity;
+		var minDist1 = 0;
+		var minDist2 = 0;
+		for (var k = 0; k < order.length; ++k)
+		{
+			var dist1 = getDistance(pointsToAdd[0].x, pointsToAdd[0].y, points[order[k]].x, points[order[k]].y);
+			var dist2 = getDistance(pointsToAdd[0].x, pointsToAdd[0].y, points[order[(k + 1) % order.length]].x, points[order[(k + 1) % order.length]].y);
+			var enlengthen = dist1 + dist2 - distances[k];
+			if (enlengthen < minEnlengthen)
+			{
+				indexToAddTo = k;
+				minEnlengthen = enlengthen;
+				minDist1 = dist1;
+				minDist2 = dist2;
+			}
+		}
+		order.splice(indexToAddTo + 1, 0, i + 3);
+		distances.splice(indexToAddTo, 1, minDist1, minDist2);
+		pointsToAdd.shift();
+	}
+	
+	return order;
+}
+
+/*
+Drags a path to a target height smoothing it at the edges and return some points on the path.
+
+TODO:
+Would be nice to tell the function what to do and how often in the arguments
+Adding painted tiles to a tile class
+*/
+function placeRandomPathToHeight(start, paintPathWithTexture, target, targetHeight, width, occurrence, strength, heightmap)
+{
+	if (paintPathWithTexture === false)
+		paintPathWithTexture = [false, ""];
+	else if (paintPathWithTexture === true)
+		paintPathWithTexture = [true, ['temp_road', "temp_road_overgrown", 'temp_grass_b']]
+	else
+		paintPathWithTexture = (paintPathWithTexture || [false, ['temp_road', "temp_road_overgrown", 'temp_grass_b']]);
+	var paintPath = paintPathWithTexture[0];
+	var pathTexture = paintPathWithTexture[1];
+	width = (width || 10);
+	occurrence = (occurrence || 2);
+	strength = (strength || 0.5);
+	heightmap = (heightmap || g_Map.height);
+	
+	var clTempPath = createTileClass();
+	var targetReached = false;
+	var position = deepcopy(start);
+	while (!targetReached)
+	{
+		rectangularSmoothToHeight(position, width, width, targetHeight, strength, heightmap);
+		if (paintPath)
+		{
+			var placer = new ClumpPlacer(0.2 * width * width, 1, 1, 1, round(position.x), round(position.y));
+			var painter = [new TerrainPainter(pathTexture), paintClass(clTempPath)];
+			createArea(placer, painter);
+		}
+		
+		// Set vars for next loop
+		var angleToTarget = getAngle(position.x, position.y, target.x, target.y);
+		var angleOff = PI * (randFloat() - 0.5);
+		position.x += occurrence * cos(angleToTarget + angleOff);
+		position.y += occurrence * sin(angleToTarget + angleOff);
+		if (getDistance(position.x, position.y, target.x, target.y) < occurrence / 2)
+			targetReached = true;
+	}
+	return clTempPath;
+}
+
+
+/**
+*  Actually do stuff
+*/
+
+/**
+* Set height limits and water level by map size
+*/
+
+/**
+* Set target min and max height depending on map size to make average steepness about the same on all map sizes
+*/
+var heightRange = { "min": MIN_HEIGHT * (g_Map.size + 512) / 8192, "max": MAX_HEIGHT * (g_Map.size + 512) / 8192 };
+
+/**
+* Set average water coverage
+*/
+var averageWaterCoverage = 1/5; // NOTE: Since terrain generation is quite unpredictable actual water coverage might vary much with the same value
+var waterHeight = -MIN_HEIGHT + heightRange.min + averageWaterCoverage * (heightRange.max - heightRange.min); // Water height in environment and the engine
+var waterHeightAdjusted = waterHeight + MIN_HEIGHT; // Water height in RMGEN
+setWaterHeight(waterHeight);
+
+
+/**
+* Generate base terrain
+*/
+
+var initialReliefmap = undefined;
+var low = heightRange.min;
+var med = 0.5 * (heightRange.min + heightRange.max);
+var high = heightRange.max;
+/**
+* Island
+*/
+// initialReliefmap = [[low, low, low], [low, high, low], [low, low, low]];
+initialReliefmap = [[low, low, low, low], [low, high, high, low], [low, high, high, low], [low, low, low, low]];
+/**
+* Mountain
+*/
+// initialReliefmap = [[low, med, low], [med, high, med], [low, med, low]];
+/**
+* Lake
+*/
+// initialReliefmap = [[high, high, high], [high, low, high], [high, high, high]];
+// initialReliefmap = [[high, high, high, high], [high, low, low, high], [high, low, low, high], [high, high, high, high]];
+/**
+* Extreme Edges
+*/
+// initialReliefmap = [[high, med, low], [med, med, med], [low, med, high]];
+// initialReliefmap = [[high, med, med, low], [med, med, med, med], [med, med, med, med], [med, med, med, med], [low, med, med, high]];
+/**
+* Extreme Center
+*/
+// initialReliefmap = [[med, med, med, med], [med, high, low, med], [med, low, high, med], [med, med, med, med]];
+setBaseTerrainDiamondSquare(heightRange.min, heightRange.max, /*0.5*/ 0.8, initialReliefmap, g_Map.height);
+/**
+* Apply simple erosion
+*/
+for (var i = 0; i < 3; ++i)
+	globalSmoothHeightmap(0.5);
+rescaleHeightmap(heightRange.min, heightRange.max);
+
+
+/**
+* Setup biome and texture height limit
+*/
+
+/**
+* myBiome presets
+*/
+
+/**
+* Height presets
+*/
+var heighLimits = [
+	heightRange.min + 1/3 * (waterHeightAdjusted - heightRange.min), // 0 Deep water
+	heightRange.min + 2/3 * (waterHeightAdjusted - heightRange.min), // 1 Medium Water
+	heightRange.min + (waterHeightAdjusted - heightRange.min), // 2 Shallow water
+	waterHeightAdjusted + 1/8 * (heightRange.max - waterHeightAdjusted), // 3 Shore
+	waterHeightAdjusted + 2/8 * (heightRange.max - waterHeightAdjusted), // 4 Low ground
+	waterHeightAdjusted + 3/8 * (heightRange.max - waterHeightAdjusted), // 5 Player and path height
+	waterHeightAdjusted + 4/8 * (heightRange.max - waterHeightAdjusted), // 6 High ground
+	waterHeightAdjusted + 5/8 * (heightRange.max - waterHeightAdjusted), // 7 Lower forest border
+	waterHeightAdjusted + 6/8 * (heightRange.max - waterHeightAdjusted), // 8 Forest
+	waterHeightAdjusted + 7/8 * (heightRange.max - waterHeightAdjusted), // 9 Upper forest border
+	waterHeightAdjusted + (heightRange.max - waterHeightAdjusted)]; // 10 Hilltop
+
+/**
+* Add tile painting presets for each biome
+*/
+var dummyActor = "actor|props/special/common/waypoint_flag.xml";
+var myBiome = [];
+/**
+* temperate 1
+*/
+myBiome.push([]);
+/**
+* snowy 2
+*/
+myBiome.push([]);
+/**
+* desert 3
+*/
+myBiome.push([]);
+/**
+* Alpine 4
+*/
+myBiome.push([]);
+myBiome[myBiome.length - 1].push({ // 0 Deep water
+	"texture": ["shoreline_stoney_a"], "actor": [["gaia/fauna_fish", "actor|geology/stone_granite_boulder.xml"], 0.02],
+	"textureHS": ["alpine_mountainside"], "actorHS": [["gaia/fauna_fish"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 1 Medium Water
+	"texture": ["shoreline_stoney_a", "alpine_shore_rocks"], "actor": [["actor|geology/stone_granite_boulder.xml"], 0.03],
+	"textureHS": ["alpine_mountainside"], "actorHS": [["actor|geology/stone_granite_boulder.xml"], 0.0] });
+myBiome[myBiome.length - 1].push({ // 2 Shallow water
+	"texture": ["alpine_shore_rocks"], "actor": [["actor|props/flora/reeds_pond_dry.xml", "actor|geology/stone_granite_large.xml", "actor|geology/stone_granite_med.xml", "actor|props/flora/reeds_pond_lush_b.xml"], 0.2],
+	"textureHS": ["alpine_mountainside"], "actorHS": [["actor|props/flora/reeds_pond_dry.xml", "actor|geology/stone_granite_med.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 3 Shore
+	"texture": ["alpine_shore_rocks_grass_50", "alpine_grass_rocky"], "actor": [["gaia/flora_tree_pine", "gaia/flora_bush_badlands", "actor|geology/highland1_moss.xml", "actor|props/flora/grass_soft_tuft_a.xml", "actor|props/flora/bush.xml"], 0.3],
+	"textureHS": ["alpine_mountainside"], "actorHS": [["actor|props/flora/grass_soft_tuft_a.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 4 Low ground
+	"texture": ["alpine_dirt_grass_50", "alpine_grass_rocky"], "actor": [["actor|geology/stone_granite_med.xml", "actor|props/flora/grass_soft_tuft_a.xml", "actor|props/flora/bush.xml", "actor|props/flora/grass_medit_flowering_tall.xml"], 0.2],
+	"textureHS": ["alpine_grass_rocky"], "actorHS": [["actor|geology/stone_granite_med.xml", "actor|props/flora/grass_soft_tuft_a.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 5 Player and path height
+	"texture": ["new_alpine_grass_c", "new_alpine_grass_b", "new_alpine_grass_d"], "actor": [["actor|geology/stone_granite_small.xml", "actor|props/flora/grass_soft_small.xml", "actor|props/flora/grass_medit_flowering_tall.xml"], 0.2],
+	"textureHS": ["alpine_grass_rocky"], "actorHS": [["actor|geology/stone_granite_small.xml", "actor|props/flora/grass_soft_small.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 6 High ground
+	"texture": ["new_alpine_grass_a", "alpine_grass_rocky"], "actor": [["actor|geology/stone_granite_med.xml", "actor|props/flora/grass_tufts_a.xml", "actor|props/flora/bush_highlands.xml", "actor|props/flora/grass_medit_flowering_tall.xml"], 0.2],
+	"textureHS": ["alpine_grass_rocky"], "actorHS": [["actor|geology/stone_granite_med.xml", "actor|props/flora/grass_tufts_a.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 7 Lower forest border
+	"texture": ["new_alpine_grass_mossy", "alpine_grass_rocky"], "actor": [["gaia/flora_tree_pine", "actor|props/flora/grass_tufts_a.xml", "gaia/flora_bush_berry", "gaia/flora_bush_berry", "gaia/flora_bush_berry", "actor|geology/highland2_moss.xml", "gaia/fauna_goat", "actor|props/flora/bush_tempe_underbrush.xml"], 0.3],
+	"textureHS": ["alpine_cliff_c"], "actorHS": [["actor|props/flora/grass_tufts_a.xml", "actor|geology/highland2_moss.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 8 Forest
+	"texture": ["alpine_forrestfloor"], "actor": [["gaia/flora_tree_pine", "gaia/flora_tree_pine", "gaia/flora_tree_pine", "gaia/flora_tree_pine", "actor|geology/highland2_moss.xml", "actor|props/flora/bush_highlands.xml"], 0.5],
+	"textureHS": ["alpine_cliff_c"], "actorHS": [["actor|geology/highland2_moss.xml", "actor|geology/stone_granite_med.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 9 Upper forest border
+	"texture": ["alpine_forrestfloor_snow", "new_alpine_grass_dirt_a"], "actor": [["gaia/flora_tree_pine", "actor|geology/snow1.xml"], 0.3],
+	"textureHS": ["alpine_cliff_b"], "actorHS": [["actor|geology/stone_granite_med.xml", "actor|geology/snow1.xml"], 0.1] });
+myBiome[myBiome.length - 1].push({ // 10 Hilltop
+	"texture": ["alpine_cliff_a"], "actor": [["actor|geology/highland1.xml"], 0.05],
+	"textureHS": ["alpine_cliff_c"], "actorHS": [["actor|geology/highland1.xml"], 0.0] });
+/**
+* medit 5
+*/
+myBiome.push([]);
+/**
+* savanah 6
+*/
+myBiome.push([]);
+/**
+* tropic 7
+*/
+myBiome.push([]);
+/**
+* autumn 8
+*/
+myBiome.push([]);
+
+/**
+* Set random biome
+*/
+while (biomeID != 4)
+	randomizeBiome();
+log("biomeID = " + biomeID); // DEBUG
+
+if (biomeID == 4)
+{
+	g_Environment.Fog.FogColor = { "r": 0.8, "g": 0.8, "b": 0.8, "a": 0 };
+	g_Environment.Water.WaterBody.Colour = { "r" : 0.0, "g" : 0.05, "b" : 0.1, "a" : 0 };
+	g_Environment.Water.WaterBody.Murkiness = 0.5;
+	rbt7 = rbt8;
+	rbt8 = rbt1
+	rbt1 = [rbt9[1]];
+	rbt9 = [rbt9[0]];
+}
+if (biomeID == 6)
+	rbt9 = [rbt9[1]];
+if (biomeID == 8)
+	rbt9 = rbt6;
+
+
+/**
+* Place start locations and apply terrain texture and decorative props by height
+*/
+
+/**
+* Get start locations
+*/
+var startLocations = getStartLocationsByHeightmap({ "min": heighLimits[4], "max": heighLimits[5] });
+var playerHeight = (heighLimits[4] + heighLimits[5]) / 2;
+
+/**
+* Place start locations
+*/
+for (var p = 0; p < g_MapSettings.PlayerData.length - 1; ++p)
+{
+	rectangularSmoothToHeight(startLocations[p], 35, 35, playerHeight, 0.8);
+	placeCivDefaultEntities(startLocations[p].x, startLocations[p].y, p + 1, BUILDING_ANGlE, { "iberWall": true });
+	// Place resources at start locations
+	var uDist = 8;
+	var uSpace = 1.2;
+	for (var j = 1; j <= 4; ++j)
+	{
+		var uAngle = BUILDING_ANGlE - PI * (2-j) / 2;
+		var count = 4;
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
+		{
+			var ux = startLocations[p].x + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
+			var uz = startLocations[p].y + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
+			if (j % 2 == 0)
+				placeObject(ux, uz, rbe6, 0, randFloat(0, 2*PI));
+			else
+				placeObject(ux, uz, rbe4, 0, randFloat(0, 2*PI));
+		}
+	}
+	ux = startLocations[p].x + 10 * cos(BUILDING_ANGlE + PI / 4);
+	uz = startLocations[p].y + 10 * sin(BUILDING_ANGlE + PI / 4);
+	// placeObject(ux, uz, rbe11, 0, randFloat(0, 2*PI));
+	ux = startLocations[p].x + 10 * cos(BUILDING_ANGlE - 3 * PI / 4);
+	uz = startLocations[p].y + 10 * sin(BUILDING_ANGlE - 3 * PI / 4);
+	// placeObject(ux, uz, rbe13, 0, randFloat(0, 2*PI));
+}
+
+/**
+* Add further stone and metal mines
+*/
+distributeEntitiesByHeight({ "min": heighLimits[4], "max": heighLimits[5] }, startLocations);
+
+/**
+* Add paths
+*/
+var pathTerrainClasseIDs = [];
+var pathPointDist = 3;
+var startLocationOrder = getOrderOfPointsForShortestClosePath(startLocations);
+// for (var i = 0; i < startLocationOrder.length; ++i)
+// {
+	// var start = startLocations[startLocationOrder[i]];
+	// var target = startLocations[startLocationOrder[(i + 1) % startLocationOrder.length]];
+	// pathTerrainClasseIDs.push(placeRandomPathToHeight(start, [true, "road_rome_a"], target, playerHeight, 10, pathPointDist, 0.2));
+// }
+
+/**
+* Calculate slope map (Not entirely sure if correct or slopeMap is the correct term)
+*/
+var slopeMap = getSlopeMap();
+
+/**
+* Calculate tileCenteredHeightMap (This has nothing to to with TILE_CENTERED_HEIGHT_MAP which should be false (default) for this map to work properly)
+*/
+var tchm = getTileCenteredHeightmap();
+
+/**
+* Divide tiles in areas by height and avoid paths
+*/
+var areas = [];
+var pathAreas = [];
+for (var i = 0; i < pathTerrainClasseIDs.length; ++i)
+	pathAreas.push([]);
+for (var h = 0; h < heighLimits.length; ++h)
+	areas.push([]);
+for (var x = 0; x < tchm.length; ++x)
+{
+	for (var y = 0; y < tchm[0].length; ++y)
+	{
+		var isPath = false;
+		for (var i = 0; i < pathTerrainClasseIDs.length; ++i)
+		{
+			if (getTileClass(pathTerrainClasseIDs[i]).countMembersInRadius(x, y, 0.5))
+			{
+				pathAreas[i].push({ "x": x, "y": y });
+				isPath = true;
+				break;
+			}
+		}
+		if (!isPath)
+		{
+			var minHeight = heightRange.min;
+			for (var h = 0; h < heighLimits.length; ++h)
+			{
+				if (tchm[x][y] >= minHeight && tchm[x][y] <= heighLimits[h])
+				{
+					areas[h].push({ "x": x, "y": y });
+					break;
+				}
+				else
+					minHeight = heighLimits[h];
+			}
+		}
+	}
+}
+
+/**
+* Get max slope of each area
+*/
+var minSlope = new Array(areas.length);
+var maxSlope = new Array(areas.length);
+for (var h = 0; h < heighLimits.length; ++h)
+{
+	minSlope[h] = Infinity;
+	maxSlope[h] = 0;
+	for (var t = 0; t < areas[h].length; ++t)
+	{
+		var x = areas[h][t].x;
+		var y = areas[h][t].y;
+		var slope = slopeMap[x][y];
+		if (slope > maxSlope[h])
+			maxSlope[h] = slope;
+		if (slope < minSlope[h])
+			minSlope[h] = slope;
+	}
+}
+
+/**
+* Paint areas by height and slope
+*/
+for (var h = 0; h < heighLimits.length; ++h)
+{
+	for (var t = 0; t < areas[h].length; ++t)
+	{
+		var x = areas[h][t].x;
+		var y = areas[h][t].y;
+		var actor = undefined;
+		if (slopeMap[x][y] < 0.5 * (minSlope[h] + maxSlope[h]))
+		{
+			var texture = myBiome[biomeID - 1][h].texture[randInt(myBiome[biomeID - 1][h].texture.length)];
+			if (randFloat() < myBiome[biomeID - 1][h].actor[1])
+				actor = myBiome[biomeID - 1][h].actor[0][randInt(myBiome[biomeID - 1][h].actor[0].length)];
+		}
+		else
+		{
+			var texture = myBiome[biomeID - 1][h].textureHS[randInt(myBiome[biomeID - 1][h].textureHS.length)];
+			if (randFloat() < myBiome[biomeID - 1][h].actorHS[1])
+				actor = myBiome[biomeID - 1][h].actorHS[0][randInt(myBiome[biomeID - 1][h].actorHS[0].length)];
+		}
+		g_Map.setTexture(x, y, texture);
+		if (actor)
+			placeObject(x + 0.5, y + 0.5, actor, 0, randFloat() * TWO_PI);
+	}
+}
+
+
+/**
+* DEBUG Collision detection START
+*/
+// for (var ox = 0; ox < collision.obstructionMap.length; ++ox)
+// {
+	// for (var oy = 0; oy < collision.obstructionMap[ox].length; ++oy)
+	// {
+		// if (collision.obstructionMap[ox][oy])
+		// {
+			// var x = (ox + 0.5) / CELL_SIZE * collision.obstructionGridSizeInMeters;
+			// var y = (oy + 0.5) / CELL_SIZE * collision.obstructionGridSizeInMeters;
+			// // log("ox = " + ox + ", oy = " + oy + ", x = " + x + ", y = " + y);
+			// if (g_Map.validT(x, y))
+				// placeObject(x, y, "actor|geology/stone_granite_small.xml", 0, randFloat() * TWO_PI);
+			// else
+				// warn("Obstruction cell {x: " + uneval(ox) + ", y: " + uneval(oy) + "} corresponds to a tile outside the map (size = " + uneval(g_Map.height.length) + "): {x: " + uneval(x) + ", y: " + uneval(y) + "}");
+		// }
+	// }
+// }
+/**
+* DEBUG Collision detection END
+*/
+
+/**
+* DEBUG Stop Timer
+*/
+log("Map generation time: " + (new Date().getTime() - genStartTime))
+
+/**
+* Export map data
+*/
+ExportMap();
+
+/**
+* DEBUG Entity IDs START
+*/
+// for (var i = 0; i < g_Map.objects.length; ++i)
+// {
+	// var id = g_Map.objects[i].id;
+	// if (i + 150 != id)
+		// log("The " + i + "-th object (should be ID " + uneval(i + 150) + ") has ID " + id);
+// }
+/**
+* DEBUG Entity IDs END
+*/
